;***************************************************************************************
;SOROTEC
;Withig 12
;77836 Rheinmnster
;Germany
;***************************************************************************************
;* MACRO CNC V2.1d Ohne Auto-WZW
;***************************************************************************************

;***************************************************************************************
;DOKU
;***************************************************************************************
;Versionshistorie
;---------------- 
;V2.1d	: Sicherheitsoffset nach Referenzfahrt neues Dialogfenster in WLMP (VF).
;V2.1c	: Bruchkontrolle - Dialog in WLMP aktiviert (VF).
;V2.1b	: Bruchkontrolle - nderung fr MDI oder Tool-Change Aufruf (VF).
;V2.1a	: Bruchkontrolle - Sensorzustand prfen (VF).
;V2.1	: Z-Null und WZ-Lngenmessung - Sensorzustand prfen (VF).
;V2.0d	: In gosub 'zero_set_rotation' falls ein Job geladen wurde dieser gestartet
;	  und somit auch die Spindel was den Messtaster zerstrt !
;		: Letzte Zeile gendert - hier darf kein STRG + G stehen !
;V2.0c: Funktionen fr Eding WIFI Handrad implementiert 
;V2.0b: Werte der Werkzeugtabelle auf Null setzen 
;V2.0a: Z-Hhenausgleich 
;V2.0 : 3D Taster fr X und Y Nullpunktermittlung 
;		Bruchkontrolle (Nicht aktiviert)
;		Spindelwarmlauf
;		Werkezugwechselbutton 
;V1.0e : Bei Wechslertyp 0 und 1 wird jetzt vor Z-Nullpunktermittlung nicht mehr geprft ob Werkezug vermessen

;Verwendete Variablen
;   #3500 INIT
;   #3501 Merker ( Wurde Werkzeug bereits Vermessen? 1=JA)
;   #3502 Merker Wird nur fr eine Berechnung bentigt
;   #3503 Merker Ja / Nein in Dialogabfragen
;   #3504 Merker ob Bruchkontrolle von Automatik aufgerufen wurde 1=Automatik
;   #3505 Merker ob Lngenmessung von Handrad 1=Handrad
;   #3510 Merker ob Werkzeugwechsel von GUI aufgerufen (1= von GUI aufgerufen)
;
; Parameter fr Typ des Werkzeuglngensensors
;---------------------------------------------
;   #4400 Werkzeuglngensensor-Typ (0= ffner, 1= Schliesser)
;
;   #4500 FREI
;
; Parameter fr Werkzeuglngenmessung
;------------------------------------- 
;   #4501 Aktuelle Werkzeuglnge
;   #4502 Alte Werkzeuglnge
;   #4503 Maximale Werkzeuglnge                                (WZL-Vermessung)
;   #4504 Antastgeschwindigkeit zum Taster "suchen" (mm/min) 	(WZL-Vermessung)
;   #4505 Tastgeschwindigkeit zum Messen(mm/min)                (WZL-Vermessung)
;   #4506 ;Sicherheitshhe als Maschinenkoordinate		(WZL-Vermessung)
;   #4507 ;Positionsangabe der X Achse 				(WZL-Vermessung)
;   #4508 ;Positionsangabe der Y Achse				(WZL-Vermessung)
;   #4509 Abstand Spindelnase zu Lngensensor von Z0 aus     	(WZL-Vermessung)
;
; Parameter fr Z-Nullpunkt Vermessung
;-------------------------------------- 
;   #4510 Tasterhhe						(ZNP-Vermessung)
;   #4511 Freifahrhhe						(ZNP-Vermessung)
;   #4512 Antastgeschwindigkeit zum Taster "suchen"		(ZNP-Vermessung)
;   #4513 Tastgeschwindigkeit zum Messen			(ZNP-Vermessung)
;-------------------------------------- 
;
;   #4514 Zwischenspeicher fr X Pos
;   #4515 Zwischenspeicher fr Y Pos
;   #4516 Zwischenspeicher fr Z Pos
;   #4517 Merker (Es wurde kein Werkzeug ausgewhlt)
;   #4518 Merker (Achse zurckfahren auf Z Vermessungspunkt)
;   #4519 Was tun nach Werkzeugvermessung: 0= vordefinierten Punkt anfahren 1= Werkstcknullpunkt fahren 2= Werkzeugwechselpos anfahren 3= Maschinennullpunkt anfahren 4= Stehen bleiben
;   #4524 Position X nach Lngenmessung   
;   #4525 Position Y nach Lngenmessung
;   #4526 Position Z nach Lngenmessung
;   #4520 Werkzeugwechseltyp 0= Mache garnix 1 = Nur WPos Anfahren 2= WPos anfahren  + Vermessen 
;   #4521 (TYP 0) Werkzeugwechselpos  X 
;   #4522 (TYP 0) Werkzeugwechselpos  Y
;   #4523 (TYP 0) Werkzeugwechselpos  Z
;   #4524 Position X nach Lngenmessung   
;   #4525 Position Y nach Lngenmessung
;   #4526 Position Z nach Lngenmessung
;   #4527 Abstand Taster zum Spindelkopf  bei Z0 G53 negativer Wert - UNBENUTZT
;   #4528 Erlaubte Toleranz Bruchkontrolle
;   #4529 Merker ob Automatische Bruchkontrolle eingeschaltet
;   #4530 Merker ob Kegelcheck eingeschaltet NICHT IN GEBRAUCH
;   #4531 Kegelhhe ber Sensor NICHT IN GEBRAUCH
;
; Parameter fr Spindel-Warmlauf
;-------------------------------- 
;   #4532 Drehzahl Stufe 1 fr Warmlauf Spindel
;   #4533 Laufzeit Stufe 1 fr Warmlauf Spindel
;   #4534 Drehzahl Stufe 2 fr Warmlauf Spindel
;   #4535 Laufzeit Stufe 2 fr Warmlauf Spindel
;   #4536 Drehzahl Stufe 3 fr Warmlauf Spindel
;   #4537 Laufzeit Stufe 3 fr Warmlauf Spindel
;   #4538 Drehzahl Stufe 4 fr Warmlauf Spindel
;   #4539 Laufzeit Stufe 4 fr Warmlauf Spindel
;   #4540 bis #4549 Leer fr mehr Stufen
;
; Parameter fr 3D-finder
;------------------------- 
;   #4544 3D-finder Sensor-Typ (0= ffner, 1= Schliesser)
;   #4545 3D-finder Taster-Lnge (Werkzeuglnge)
;   #4546 3D-finder Kugelradius
;   #4547 3D-finder Radius-Offset
;
;   #4548 3D-finder Tgeschwindigkeit zum Taster-Anfahren (mm/min)
;   #4549 3D-finder Tastgeschwindigkeit zum Messen (mm/min)
;
; Parameter fr Werkstck antasten (SOROTEC)
;--------------------------------------------
;   #4550 Nullpunktermittlung Merker Richtung
;   #4551 Nullpunktermittlung Versatz X+
;   #4552 Nullpunktermittlung Versatz X-
;   #4553 Nullpunktermittlung Versatz Y+
;   #4554 Nullpunktermittlung Versatz Y-
;   #4600 Ab hier fr Wechsler reserviert 
;
; Parameter fr Referenz-Offset
;------------------------------
;   #4631 sicherheitsoffset in X nach der Referenzfahrt
;   #4632 sicherheitsoffset in Y nach der Referenzfahrt
;   #4633 sicherheitsoffset in Z nach der Referenzfahrt
;
; SYSTEM VARIABLEN
;------------------
;   #5001 Aktuelle X Pos (Arbeitskoordinate)
;   #5002 Aktuelle Y Pos (Arbeitskoordinate)
;   #5003 Aktuelle Z Pos (Arbeitskoordinate)
;   #5004 Aktuelle A Pos (Arbeitskoordinate)
;   #5005 Aktuelle B Pos (Arbeitskoordinate)
;   #5006 Aktuelle C Pos (Arbeitskoordinate)
;   #5008 Aktuelle Werkzeugnummer
;   #5010 Aktuelle Werkzeuglnge
;   #5011 Neue Werkzeugnummer
;   #5015 Werkzeugwechsel-Vorgang (0= Wechsel nicht ausgefhrt, 1= Wechsel wurde ausgefhrt)
;   #5053 Sensor-Schaltpunkt Z Pos (Maschinenkoordinate), wenn Sensoreingang den Zustand ndert
;   #5061 Sensor-Schaltpunkt X Pos (Arbeitskoordinate)
;   #5062 Sensor-Schaltpunkt Y Pos (Arbeitskoordinate)
;   #5063 Sensor-Schaltpunkt Z Pos (Arbeitskoordinate)
;   #5064 Sensor-Schaltpunkt A Pos (Arbeitskoordinate)
;   #5065 Sensor-Schaltpunkt B Pos (Arbeitskoordinate)
;   #5066 Sensor-Schaltpunkt C Pos (Arbeitskoordinate)
;   #5067 Sensorimpuls:  1 = wenn Sensoreingang den Zustand ndert
;   #5068 Sensorzustand: 0 = geschlossen, 1 = geffnet (wenn der Sensor als ffner konfigfuriert ist)
;   #5071 Aktuelle X Pos (Maschinenkoordinate)
;   #5072 Aktuelle Y Pos (Maschinenkoordinate)
;   #5073 Aktuelle Z Pos (Maschinenkoordinate)
;   #5074 Aktuelle A Pos (Maschinenkoordinate)
;   #5075 Aktuelle B Pos (Maschinenkoordinate)
;   #5076 Aktuelle C Pos (Maschinenkoordinate)
;   #5113 Positives Limit Z (Maschinenkoordinate)
;   #5380 Abfrage ob Simulation Modus [0=Nein NormalModus,  1=Ja SimulationsModus]
;   #5397 Abfrage ob sich die Maschine im Render Modus befindet [0=Nein NormalModus,  1=Ja RenderModus]
;   #5398 DlgMsg Return-Value [1=OK,  -1=CANCEL]
;   #5399 Return-Value der Funktionen M55 und M56

;***************************************************************************************
IF [#3500 == 0] then ; INIT
	#3500 = 1
	IF [#4504 == 0] THEN  	
		#4504 =50	;Antastgeschwindigkeit zum Taster "suchen" (mm/min)
	ENDIF
	IF [#4505 == 0] THEN  	
		   #4505 =10  	;Tastgeschwindigkeit zum Messen(mm/min)  
	ENDIF
	IF [#4511 == 0] THEN  	
	   	#4511 =10	;Freifahrhhe		
	ENDIF
	IF [#4512 == 0] THEN  	
		#4512 = 50  	;Antastgeschwindigkeit zum Taster "suchen"
	ENDIF  
	IF [#4513 == 0] THEN  	
		#4513 =20  	;Tastgeschwindigkeit zum Messen
	ENDIF
ENDIF
;***************************************************************************************

;---------------------------------------------------------------------------------------
Sub user_1 ; Z-Nullpunktermittlung
;---------------------------------------------------------------------------------------
; #185  - TEMP-Variable (Sensor Fehler-Zustand)


	IF [[#3501 == 1] or [#4520 < 2]]then	; Wurde Werkzeug bereits Vermessen? 1=JA oder ist lngensensor inaktiv geschaltet

		;--------------------------------------------------
		; Sensorzustand prfen
		;--------------------------------------------------
		 IF [#4400 == 0]				; Wenn ffner (#4400 = 0)
		     #185 = 1					;     Fehler-Zustand (1= offen)
		 ELSE						; Wenn Schliesser (#4400 = 1)
		     #185 = 0					;     Fehler-Zustand (0= geschlossen)
		 ENDIF

		 IF [#5068 == #185]					; Sensorzustand prfen
			dlgmsg "Werkzeugsensor nicht angeschlossen"
			IF [#5398 == 1]					; OK-Taste
			    IF [#5068 == #185]				; Sensor immer noch nicht angeschlossen
				errmsg "Z-Nullpunktermittlung abgebrochen -> Sensor Error"
			    ENDIF
			ELSE
			    errmsg "Z-Nullpunktermittlung abgebrochen -> Sensor Error"
			ENDIF	
		 ENDIF
		;--------------------------------------------------


		#4518 = 0 						; Merker Achse zurckfahren auf Z Vermessungspunkt) Sicherheitshalber rcksetzen
		IF [#3505 == 0] 					; Merker ob Lngenmessung von Handrad 1=Handrad
			DlgMsg "Z-Nullpunkt ermitteln" 
		ENDIF	
		#3505 = 0						; Merker ob Lngenmessung von Handrad 1=Handrad
		IF [[#5398 == 1] AND [#5397 == 0]]			; OK Taste gedrckt und RenderModus AUS !!
			M5						; Spindel ausschalten
			msg "Taster wird angefahren"	
			G38.2 G91 z-50 F[#4512] 			; Schnelles anfahren auf Taster bis Schaltsignalnderung
			IF [#5067 == 1]					; Wenn Sensor gefunden wurde
			    G38.2 G91 z20 F[#4513]			; Langsam von Taster runterfahren zur exakten Z-Ermittlung
			    G90
	 		    IF [#5067 == 1]				; Wenn Sensor gefunden wurde              
				G0 Z#5063				; Schaltpunkt anfahren	
				G92 Z[#4510] 				; Z-Nullpunkt bernehmen

				G0 Z[#4510 + 5] 			; Taster 5mm Freifahren
				msg"Z-Nullpunktermittlung fertig"
			    ELSE
				G90 
				errmsg "FEHLER: Sensor hat nicht geschaltet"
			    ENDIF

			ELSE	;CANCEL

			    G90 
			    DlgMsg "WARNUNG: Kein Sensor gefunden! Erneut Versuchen?" 
			    IF [#5398 == 1] ;OK   				
				GoSub user_1
			    ELSE
				errmsg "Messung wurde abgebrochen!"
			    ENDIF
			ENDIF
		ENDIF   	
	ELSE
		#3505 = 0					; Merker ob Lngenmessung von Handrad 1=Handrad
		DlgMsg "WARNUNG - Werkzeug zuerst Vermessen" 
		IF [#5398 == 1] 	;OK
	   		#4514 = #5071				; Zwischenspeicher fr X Pos
			#4515 = #5072				; Zwischenspeicher fr Y Pos
			#4516 = #5073				; Zwischenspeicher fr Z Pos
			#4518 = 1				; Merker setzen das zurckpositioniert wird
			GoSub user_2
		ENDIF
	ENDIF
Endsub

;***************************************************************************************
Sub user_2 ; Werkzeuglngenmessung
;---------------------------------------------------------------------------------------
; #185  - TEMP-Variable (Sensor Fehler-Zustand)
; #4509 - Abstand Taster zum Spindelkopf  bei Z0 (G53)(negativer Wert)
;


  #5016 = [#5008]	; Aktuelle Werkzeugnummer
  #5017 = [#4503]	; Maximale Werkzeuglnge
  #5019 = [#4507]	; Werkzeuglngensensorposition X-Achse
  #5020 = [#4508]	; Werkzeuglngensensorposition Y-Achse
  #5021 = 0 		; Gemessene Werkzeuglnge wird hier eingetragen

   ;-VF-----------------------------------------------
   ; Fr 3D-Taster keine Lngenmessung
   ;--------------------------------------------------
    IF [#5008 > 97]			; Werkzeuge 98 und 99 sind 3D-Taster - keine Lngenmessung
	msg "Werkzeug ist 3D-Taster -> Lngenmessung nicht ausgefhrt"
	M30				; Programmende
    ENDIF
   ;--------------------------------------------------

   ;--------------------------------------------------
   ; Sensorzustand prfen
   ;--------------------------------------------------
    IF [#4400 == 0]				; Wenn ffner (#4400 = 0)
	#185 = 1				;     Fehler-Zustand (1= offen)
    ELSE					; Wenn Schliesser (#4400 = 1)
	#185 = 0				;     Fehler-Zustand (0= geschlossen)
    ENDIF

    IF [#5068 == #185]					; Sensorzustand prfen
	dlgmsg "Werkzeugsensor nicht angeschlossen"
	IF [#5398 == 1]					; OK-Taste
	    IF [#5068 == #185]				; Sensor immer noch nicht angeschlossen
		errmsg "Werkzeuglngenmessung abgebrochen -> Sensor Error"
	    ENDIF
	ELSE
	    errmsg "Werkzeuglngenmessung abgebrochen -> Sensor Error"
	ENDIF	
    ENDIF
   ;--------------------------------------------------

    msg "Werkzeug wird vermessen"
    dlgmsg "Soll Werkzeug Vermessen werden" "Werkzeuglnge ca:" 5017

    IF [[#5398 == 1] AND [#5397 == 0]]		; OK Taste wurde gedrckt und RenderModus ist AUS !!

	IF [[#5017] < 0] THEN					; Testen ob Werkzeuglnge negativ
	    DlgMsg "!!! WARNUNG: Werkzeuglnge darf nicht negativ sein !!!" "Werkzeuglnge ca:" 5017
	    ; IF [#5398 == 1] ;OK
	    ;	GoSub user_2
	    ; ELSE
	    ;	GoSub user_2
	    ; ENDIF
	ENDIF

	IF [[#4509 + #5017 + 10] > [#4506]] THEN		; Testen ob errechneter Wert hher wie sicherheitshhe ist
	    DlgMsg "!!! WARNUNG: Werkzeug zu lang !!!" "Werkzeuglnge ca:" 5017
	    ; IF [#5398 == 1] ;OK
	    ;	GoSub user_2
	    ; ELSE
	    ;	GoSub user_2
	    ; ENDIF
	ENDIF

	IF [ [#5017 < 0] OR [[#4509 + #5017 + 10] > [#4506]] ]	;#VF# Immer noch falsche Eingabe
	    errmsg "Werkzeuglngenmessung Abgebrochen"
	ENDIF


	M5 M9
	G53 G0 z[#4506]						; Z Sicherheitshhe anfahren [Maschinenkoordinate] 
       	G53 G0 x[#5019] y[#5020]				; Werkzeuglngensensor Position anfahren

	;--------------------------------
	; Eilgeschwindigkeit zum Sensor 
	;--------------------------------
	 G53 G0 z[#4509 + #5017 + 10]				; Abstand Z zum Sensor in G0 anfahren - Spindelkopfabstand + max.Werkzeuglnge + 10
	;--------------------------------

	G53 G38.2 Z[#4509] F[#4504]				; Z mit Antastgeschwindigkeit #4504 an den Sensor fahren

	IF [#5067 == 1]						; Wenn Sensor gefunden wurde
	    G91 G38.2 Z20 F[#4505]				; Z mit Messgeschwindigkeit #4505 vom Sensor wegfahren bis Taster erneut schaltet
	    G90							; Modus fr absolute Koordinaten

	    IF [#5067 == 1]					; Wenn Sensor gefunden wurde, wird Tastpunkt in #5053 gespeichert

		G00 g53 z#4506					; Z Sicherheitshhe anfahren [Maschinenkoordinate]

		;***********Bei Direktvermessung Tabelle auf 0 schreiben
		#[5400 + #5016] = 0 ;[#5053 - #4509]			;Berechnete Werkzeuglnge in Tabelle speichern
		#[5500 + #5016] = 0 ;#5018				;Werkzeugdurchmesser in Tabelle speichern
		;***********Bei Direktvermessung Tabelle auf 0 schreiben Ende

		#5021 = [#5053 - #4509]				; Berechnung Werkzeuglnge = Tastpunkt  - chuck height
		msg "Werkzeuglnge = " #5021

		IF [#3501 == 1] 				; Wurde Werkzeug bereits Vermessen? 1=JA
		    #4502 = [#4501]				; Alte Werkzeuglnge speichern
		    #4501 = [#5021]				; Aktuelle Werkzeuglnge speichern = Ermittelte Werkzeuglnge
		    #3502 = [#4501 - #4502]			; Werkzeuglngenunterschied ausrechnen

		    G92 Z[#5003 - #3502]		 	; Z-Nullpunkt verschieben

		    ;Werkzeuglaenge und Werkzeugdurchmesser in Tabelle speichern
		    ;#[5400 + #5016] = [#5053 - #4509]			;Berechnete Werkzeuglnge in Tabelle speichern
		    ;#[5500 + #5016] = #5018				;Werkzeugdurchmesser in Tabelle speichern
		    ;msg "Gemessene Werkzeuglaenge="#[5400 + #5016]" gespeichert in Werkzeugnr. "#5016
		ELSE
		    #4501 = [#5021]				; Aktuelle Werkzeuglnge eintragen
            	ENDIF

		IF [#4518 == 1] then				; Merker: Zurckfahren auf Z Vermessungspunkt (1=JA, 0=NEIN)
		    G0 G53 Z#4506				; Z Sicherheitshhe anfahren [Maschinenkoordinate]
		    G0 G53 X#4514 Y#4515			; Repositionieren
		    #4518 = 0					; Merker: Zurckfahren auf Vermessungspunkt (1=JA, 0=NEIN)
		    #3501 = 1					; Merker: Wurde Werkzeug bereits Vermessen? (1=JA, 0=NEIN)
		ELSE
		    IF [#4519 == 0] then			; ### 0 ### Was tun nach Werkzeugvermessung: 0= vordefinierten Punkt anfahren
			G0 G53 Z#4506				; Z Sicherheitshhe anfahren [Maschinenkoordinate]
			G0 G53 X#4524 Y#4525			; Vordefinierten Punkt anfahren 
		    ENDIF

		    IF [#4519 == 1] then			; ### 1 ### Was tun nach Werkzeugvermessung: 1= Werkstcknullpunkt fahren 
			G0 G53 Z#4506				; Z Sicherheitshhe anfahren [Maschinenkoordinate]
			G0 X0 Y0				; Werkstcknullpunkt anfahren
		    ENDIF

		    IF [#4519 == 2] then			; ### 2 ### Was tun nach Werkzeugvermessung: 2= Manuelle Werkzeugwechselpos anfahren
			G0 G53 Z#4523				; Werkzeugwechselpos Z anfahren
			G0 G53 X#4521 Y#4522			; Werkzeugwechselpos XY anfahren
		    ENDIF

		    IF [#4519 == 3] then			; ### 3 ### Was tun nach Werkzeugvermessung: 3= Maschinennullpunkt anfahren
			G0 G53 Z#4506				; Z Sicherheitshhe anfahren [Maschinenkoordinate]
			G0 G53 X0 Y0				; Maschinennullpunkt anfahren
		    ENDIF

		    ; IF [#4519 == 4] then			; ### 4 ### Was tun nach Werkzeugvermessung: 4= Stehen bleiben
		    ; ENDIF
					
		ENDIF

		#4518 = 0					; Merker: Zurckfahren auf Vermessungspunkt (1=JA, 0=NEIN)
           	#3501 = 1					; Merker: Wurde Werkzeug bereits Vermessen? (1=JA, 0=NEIN)
	    ELSE
		errmsg "FEHLER: Kein Sensor gefunden - RESET BETTIGEN"
	    ENDIF

	ELSE
	    errmsg "FEHLER: Kein Sensor gefunden - Messung abgebrochen"
	ENDIF
    ENDIF

Endsub

;***************************************************************************************
Sub user_3 ; Bruchkontrolle des Frsers
;---------------------------------------------------------------------------------------
; #185  - TEMP-Variable (Sensor Fehler-Zustand)
; #4509 - Abstand Taster zum Spindelkopf  bei Z0 (G53)(negativer Wert)
; #5021 - Gemessene Werkzeuglnge aus der vorherigen Messung
;


    ; #4529 = 0
   ; IF [#4529 == 1]			 					; #4529 Merker ob Automatische Bruchkontrolle eingeschaltet

	IF [#3501 == 1]								; Merker (Wurde Werkzeug bereits Vermessen? 1=JA)

		;--------------------------------------------------
		; Sensorzustand prfen
		;--------------------------------------------------
		 IF [#4400 == 0]				; Wenn ffner (#4400 = 0)
		     #185 = 1					;     Fehler-Zustand (1= offen)
		 ELSE						; Wenn Schliesser (#4400 = 1)
		     #185 = 0					;     Fehler-Zustand (0= geschlossen)
		 ENDIF

		 IF [#5068 == #185]					; Sensorzustand prfen
			dlgmsg "Werkzeugsensor nicht angeschlossen"
			IF [#5398 == 1]					; OK-Taste
			    IF [#5068 == #185]				; Sensor immer noch nicht angeschlossen
				#3504 = 0				; Merker ob Bruchkontrolle von Automatik aufgerufen wurde 1=Automatik
				errmsg "Z-Nullpunktermittlung abgebrochen -> Sensor Error"
			    ENDIF
			ELSE
			    #3504 = 0					; Merker ob Bruchkontrolle von Automatik aufgerufen wurde 1=Automatik
			    errmsg "Z-Nullpunktermittlung abgebrochen -> Sensor Error"
			ENDIF	
		 ENDIF
		;--------------------------------------------------

		msg "Bruchkontrolle"
		M5 M9
		G53 G0 z[#4506]							; Sicherheitshhe 
		G53 G0 y[#5020]  						; XYChange Vorsict Sonderfall    
		G53 G0 x[#5019]							; XYChange Vorsict Sonderfall
		G53 G0 z[#4509 + #5017 + 10]

		G53 G38.2 Z[#4509] F[#4504] 
		IF [#5067 == 1]							; Wenn Sensor gefunden wurde
			G91 G38.2 Z20 F[#4505] 
			G90
			IF [#5067 == 1]						; Wenn Sensor gefunden wurde, wird Tastpunkt in #5053 gespeichert
				#4501 = [#5053 - #4509]				; Berechnung aktuelle Werkzeuglnge = Tastpunkt  - chuck height
				G00 G53 z#4506
				IF [[[#5021 + #4528] > [#4501]]  and [[#5021 - #4528] < [#4501]]]
					msg "Okay"
					msg " Massabweichung:" [#5021 - #4501]	
					
				ELSE
					#3504 = 0				; Merker ob Bruchkontrolle von Automatik aufgerufen wurde 1=Automatik
					G53 G0 Z[#4523]				; Sicherheitshhe
					G53 G0 X[#4521] 			; Manuelle Werkzeugwechselpos X XYchange
					G53 G0 Y[#4522]				; Manuelle Werkzeugwechselpos Y XYchange
					Dlgmsg "Werkzeug Verschlissen, fortfhren?" " Massabweichung:" 4501	
					IF [#5398 == 1] ;OK
						Dlgmsg "WARNUNG: Auftrag wird fortgefhrt"	
					ELSE
						#3504 = 0			; Merker ob Bruchkontrolle von Automatik aufgerufen wurde 1=Automatik
						errmsg "Werkzeug Verschlissen, abbruch"
					ENDIF
				ENDIF

				IF [#3504 == 0]					; Merker ob Bruchkontrolle von Automatik aufgerufen wurde 1=Automatik
					IF [#4519 == 0] then			; Was tun nach Werkzeugvermessung 0= vordefinierten Punkt anfahren
						G0 G53 Z#4506				; Sicher Z 
						G0 G53 X#4524 				; Vordefinierten Punkt anfahren XYchange
						G0 G53 Y#4525				; Vordefinierten Punkt anfahren XYchange
					ENDIF
			
					IF [#4519 == 1] then			; Was tun nach Werkzeugvermessung 1= Werkstcknullpunkt fahren 
						G0 G53 Z#4506				; Sicher Z 
						G0 X0 					; Werkstcknullpunkt anfahren anfahren XYchange
						G0 Y0 					; Werkstcknullpunkt anfahren anfahren XYchange
					ENDIF
					
					IF [#4519 == 2] then			; Was tun nach Werkzeugvermessung 2= Werkzeugwechselpos anfahren
						G0 G53 Z#4523				; Werkzeugwechselpunkt anfahren
						G0 G53 X#4521 				; Werkzeugwechselpunkt anfahren XYchange
						G0 G53 Y#4522				; Werkzeugwechselpunkt anfahren XYchange
					ENDIF

					IF [#4519 == 3] then			; Was tun nach Werkzeugvermessung 3= Maschinennullpunkt anfahren
						G0 G53 Z#4506				; Sicher Z 
						G53 X0 					; Maschinennullpunkt anfahren XYchange
						G53 Y0 					; Maschinennullpunkt anfahren XYchange
					ENDIF

					IF [#4519 == 4] then			; Was tun nach Werkzeugvermessung 4= Stehen bleiben		
					ENDIF
				ENDIF					

			ELSE
				#3504 = 0					; Merker ob Bruchkontrolle von Automatik aufgerufen wurde 1=Automatik
				errmsg "FEHLER: Kein Sensor gefunden"
			ENDIF
		ELSE
			#3504 = 0						; Merker ob Bruchkontrolle von Automatik aufgerufen wurde 1=Automatik
			errmsg "FEHLER: Kein Sensor gefunden"
		ENDIF

	ELSE
	   DlgMsg "Werkzeug wurde noch nicht Vermessen"
	ENDIF
	#3504 = 0								; Merker ob Bruchkontrolle von Automatik aufgerufen wurde 1=Automatik

   ; ELSE
   ;	DlgMsg "Bruchkontrolle nicht aktiviert"
   ; ENDIF

Endsub

;***************************************************************************************
Sub user_4  ; Spindel Warmlauf 
;---------------------------------------------------------------------------------------
;   #4532 Drehzahl Stufe 1 fr Warmlauf Spindel
;   #4533 Laufzeit Stufe 1 fr Warmlauf Spindel
;   #4534 Drehzahl Stufe 2 fr Warmlauf Spindel
;   #4535 Laufzeit Stufe 2 fr Warmlauf Spindel
;   #4536 Drehzahl Stufe 3 fr Warmlauf Spindel
;   #4537 Laufzeit Stufe 3 fr Warmlauf Spindel
;   #4538 Drehzahl Stufe 4 fr Warmlauf Spindel
;   #4539 Laufzeit Stufe 4 fr Warmlauf Spindel

	DlgMsg "Spindelwarmlauf Starten?"
	IF [#5398 == 1]	 ;OK
		G53 G00 Z0
		M03 S#4532
		G04 P#4533	
		M03 S#4534
		G04 P#4535	
		M03 S#4536
		G04 P#4537	
		M03 S#4538
		G04 P#4539	
		M05
	ENDIF
Endsub

;***************************************************************************************
Sub user_5  ; Werkzeug wechseln
;---------------------------------------------------------------------------------------

    Dlgmsg "Welches Werkzeug soll eingewechselt werden" " Neue Werkzeugnr.:" 5011
    IF [#5398 == 1] ;OK
	IF [#5011 > 99] THEN
	    Dlgmsg "Werkzeugnr Ungltig: Bitte Werkzeugnummer 1..99 Auswhlen"
	    #5011 = #5008				; Neue Werkzeugnummer zurck setzen wie es war
	ELSE
	    #3510 = 1					; Merker ob Werkzeugwechsel von GUI aufgerufen (1= von GUI aufgerufen)
	    gosub change_tool

	    #3510 = 0					; Merker ob Werkzeugwechsel von GUI aufgerufen zurck setzen
	ENDIF
    ENDIF

Endsub

;***************************************************************************************
Sub user_6  ; Werkzeugmanipulation
;---------------------------------------------------------------------------------------
    #5011 = [#5008]
    Dlgmsg "!!! Werkzeugmanipulation !!!" "Alte Werkzeugnr" 5008" Neue Werkzeugnr" 5011
    IF [#5011 > 99] THEN
	Dlgmsg "Werkzeugnr Ungltig: Bitte Werkzeugnummer 1..99 Auswhlen"
	#5011 = #5008					; Neue Werkzeugnummer zurck setzen wie es war
	M30
    ELSE
	#5015 = 1					; Wurde werkzeug erfolgreich gewechselt 1=Ja
	IF [[#5011] > 0] THEN
	    M6 T[#5011]
	    ;G43
	ELSE
	    M6 T[#5011]
	ENDIF

    ENDIF

Endsub

;***************************************************************************************
Sub user_7
;---------------------------------------------------------------------------------------
   	msg "sub user_7"
	DlgMsg "Keine Funktion hinterlegt"
Endsub

;***************************************************************************************
Sub user_8
;---------------------------------------------------------------------------------------
;   #4550 Nullpunktermittlung Merker Richtung
;   #4551 Nullpunktermittlung Versatz X+
;   #4552 Nullpunktermittlung Versatz X-
;   #4553 Nullpunktermittlung Versatz Y+
;   #4554 Nullpunktermittlung Versatz Y-
Dlgmsg "Nullpunkt ermitteln 1 = X+ / 2 = X- / 3 = Y+  / 4 = Y-" "Richtung:" 4550 
IF [#4550 == 0]
ENDIF

;---- X-Plus-----------------------------------------------------------------------------------
IF [#4550 == 1]
	G91 G38.2 x20 F[#4504]
	G90
	IF [#5067 == 1]					; Wenn Sensor gefunden wurde
	    G91 G38.2 x-10 F[#4505]
		G90
		IF [#5067 == 1]				; Wenn Sensor gefunden wurde
			G92 X#4551
			G91 G00 x-1 
			G90
		ENDIF
	ELSE
		DlgMsg "FEHLER: Kein Sensor gefunden - Messung abgebrochen"
	ENDIF 
	#4550 = 0
ENDIF
;---- X-Minus-----------------------------------------------------------------------------------
IF [#4550 == 2]
	G91 G38.2 x-20 F[#4504]
	G90
	IF [#5067 == 1]					; Wenn Sensor gefunden wurde
	    G91 G38.2 x10 F[#4505]
		G90
		IF [#5067 == 1]				; Wenn Sensor gefunden wurde
			G92 X#4552
			G91 G00 x1 
			G90
		ENDIF
	ELSE
		DlgMsg "FEHLER: Kein Sensor gefunden - Messung abgebrochen"
	ENDIF 
	#4550 = 0
ENDIF
;---- Y-Plus-----------------------------------------------------------------------------------
IF [#4550 == 3]
	G91 G38.2 y20 F[#4504]
	G90
	IF [#5067 == 1]					; Wenn Sensor gefunden wurde
	    G91 G38.2 y-10 F[#4505]
		G90
		IF [#5067 == 1]				; Wenn Sensor gefunden wurde
			G92 y#4553
			G91 G00 y-1 
			G90
		ENDIF
	ELSE
		DlgMsg "FEHLER: Kein Sensor gefunden - Messung abgebrochen"
	ENDIF 
	#4550 = 0
ENDIF 
;---- Y-Minus-----------------------------------------------------------------------------------
IF [#4550 == 4]
	G91 G38.2 y-20 F[#4504]
	G90
	IF [#5067 == 1]					; Wenn Sensor gefunden wurde
	    G91 G38.2 y10 F[#4505]
		G90
		IF [#5067 == 1]				; Wenn Sensor gefunden wurde
			G92 y#4554
			G91 G00 y1 
			G90
		ENDIF
	ELSE
		DlgMsg "FEHLER: Kein Sensor gefunden - Messung abgebrochen"
	ENDIF 
	#4550 = 0
ENDIF
ENDSUB

;***************************************************************************************
Sub user_9
;---------------------------------------------------------------------------------------
   	msg "sub user_9"
	DlgMsg "Keine Funktion hinterlegt"
Endsub

;***************************************************************************************
Sub user_10
;---------------------------------------------------------------------------------------
  	DlgMsg "Soll Maschinennullpunkt angefahren werden?"
	if [#5398 == 1] ;OK
	   	G53 G0 Z0
	    	G53 X0 Y0
	ENDIF
Endsub

;***************************************************************************************
Sub home_z ;Homing per axis
;---------------------------------------------------------------------------------------
    msg "Referenziere Achse Z"
    M80
    g4p0.2
    home z
Endsub
;***************************************************************************************
Sub home_x
    msg "Referenziere Achse  X"
    M80
    g4p0.2
    home x
    ;homeTandem X
Endsub
;***************************************************************************************
Sub home_y
    msg "Referenziere Achse  Y"
    M80
    g4p0.2
    home y
    ;homeTandem Y
Endsub
;***************************************************************************************
Sub home_a
    msg "Referenziere  Achse A"
    M80
    g4p0.2
    home a
Endsub
;***************************************************************************************
Sub home_b
    msg "Referenziere  Achse  B"
    M80
    g4p0.2
    home b
Endsub
;***************************************************************************************
Sub home_c
    msg "Referenziere  Achse  C"
    M80
    g4p0.2
    home c
Endsub
;***************************************************************************************
;Home all axes
sub home_all
    gosub home_z
    gosub home_y
    gosub home_x
    gosub home_a
    gosub home_b
    gosub home_c

   ; G53 G01 X0 Y0 Z0 F1000; Achse X, Y und Z auf 0 Fahren    
    G53 G01 Z#4633 F2000			; Achse Z auf Referenzoffset fahren
    G53 G01 X#4631 Y#4632 F2000			; Achse X und Y auf Referenzoffset fahren

    msg"Referenzierung fertig"	
    ;homeIsEstop on ;diese Zeile Einkommentieren wenn Refschalter = Endschalter  

    #3501 = 0					; INIT - Werkzeug noch nicht Vermessen
    #3504 = 0					; INIT - Merker ob Bruchkontrolle von Automatik aufgerufen wurde 1=Automatik

    m30
endsub

;***************************************************************************************
Sub zero_set_rotation
;---------------------------------------------------------------------------------------
    msg "Ersten Punkt antasten und mit STRG + G fortfahren"
	m0
	#5020 = #5071 ;x1
	#5021 = #5072 ;y1
    msg "Zweiten Punkt antasten und mit STRG + G fortfahren"
	m0
	#5022 = #5071 ;x2
	#5023 = #5072 ;y2
	#5024 = ATAN[#5023 - #5021]/[#5022 - #5020]
	if [#5024 > 45]
       #5024 = [#5024 - 90] ;Punkte in Y Achse
	endif
	g68 R#5024
	msg "Koordinatensystem mit G68 R"#5024" gedreht"
	msg "*** Bitte Messtaster entfernen!!! ***"
Endsub

;***************************************************************************************
sub change_tool
;---------------------------------------------------------------------------------------

    #5015 = 0						; Merker: Werkzeugwechsel noch nicht ausgefhrt
    M5 M9						; Spindel AUS, Khlung AUS

    IF [#5397 == 0]					; Render Modus AUS (0= Aus)

	;---------------------------------------------------------------------------------------
	; 0 = Wechsel ignorieren
	;---------------------------------------------------------------------------------------
	IF [[#4520] == 0] 			; Werkzeugwechslertyp  0= Wechsel ignorieren 1 = Nur WPos Anfahren 2= WPos anfahren  + Vermessen 
		#5015 = 1				; Wurde werkzeug erfolgreich gewechselt 1=Ja
	ENDIF

	;---------------------------------------------------------------------------------------
	; 1 = Nur WPos Anfahren
	;---------------------------------------------------------------------------------------
	IF [[#4520] == 1] 			; Werkzeugwechslertyp  0= Mache garnix 1 = Nur WPos Anfahren 2= WPos anfahren  + Vermessen 
		#3503 = 1				; Werkzeugnummer bereits eingelegt  1=Ja
		IF [[#5011] == [#5008]] THEN
			Dlgmsg "Werkzeug bereits eingelegt. Trotzdem wechseln?"
			IF [#5398 == 1] ;OK
				#3503 = 1
			ELSE
				#3503 = 0
			ENDIF
		ENDIF

		IF [#3503 == 1] THEN
			G53 G0 Z[#4523]			; Sicherheitshhe
			G53 G0 X[#4521] Y[#4522]	; Werkzeugwechselpos X Y

			Dlgmsg "Bitte Werkzeug einwechseln" "Alte Werkzeugnr.:" 5008" Neue Werkzeugnr.:" 5011
			if [#5398 == 1] ;OK
				IF [#5011 > 99] THEN
					Dlgmsg "Werkzeugnr Ungltig: Bitte Werkzeugnummer 1..99 Auswhlen"
					IF [#5398 == 1] ;OK
						gosub change_tool
					ELSE
						errmsg "Werkzeugwechsel abgebrochen"
					ENDIF
					
				ELSE
					#5015 = 1		; Werkzeugwechsel ausgefhrt 1=Ja
				ENDIF
			ELSE
				errmsg "Werkzeugwechsel abgebrochen"
			ENDIF
	
		ENDIF
	ENDIF

	;---------------------------------------------------------------------------------------
	; 2= WPos anfahren  + Vermessen 
	;---------------------------------------------------------------------------------------
	IF [[#4520] == 2] 				; Werkzeugwechslertyp  0= Mache garnix 1 = Nur WPos Anfahren 2= WPos anfahren  + Vermessen 
		#3503 = 1					; Werkzeugnummer bereits eingelegt  1=Ja
		IF [[#5011] == [#5008]] THEN
			Dlgmsg "Werkzeug bereits eingelegt. Trotzdem wechseln?"
			IF [#5398 == 1] ;OK
				#3503 = 1
			ELSE
				#3503 = 0
			ENDIF
		ENDIF

		IF [#3503 == 1] THEN

			IF [[#5008 > 0] AND [#4529 == 1]]	; Aktuelle Werkzeugnummer grsser 0 und Bruchkontrolle aktiviert
				#3504 = 1			; Merker ob Bruchkontrolle von Automatik aufgerufen wurde 1=Automatik
				GOSUB user_3			; Bruchkontrolle aufrufen
				#3504 = 0			; Merker ob Bruchkontrolle von Automatik aufgerufen wurde 1=Automatik
			ELSE
				msg "Bruchkontrolle nicht ausgefhrt"
			ENDIF

			G53 G0 Z[#4523]				; Sicherheitshhe
			G53 G0 X[#4521] Y[#4522]		; Werkzeugwechselpos X Y

			Dlgmsg "Bitte Werkzeug einwechseln" "Alte Werkzeugnr.:" 5008 " Neue Werkzeugnr.:" 5011
			IF [#5398 == 1] ;OK
				IF [#5011 > 99]
					Dlgmsg "Werkzeugnr Ungltig: Bitte Werkzeugnummer 1..99 Auswhlen" " Neue Werkzeugnr.:" 5011
					IF [#5398 == 1] ;OK
				 	    IF [#5011 > 99]
						errmsg "Werkzeugnr Ungltig -> Werkzeugwechsel abgebrochen"
					    ENDIF
					ELSE
					    errmsg "Werkzeugwechsel abgebrochen"
					ENDIF
				ENDIF

				#5015 = 1			; Werkzeugwechsel ausgefhrt 1=Ja
			ELSE
			   	errmsg "Werkzeugwechsel abgebrochen" 
			ENDIF

		ENDIF
	ENDIF
	;---------------------------------------------------------------------------------------

	IF [[#5015] == 1] THEN   
		msg "Werkzeugnr.: " #5008" mit Werkzeugnr.: " #5011 " gewechselt"

	        M6 T[#5011]				; Neue Werkzeugnummer setzen

		IF [#4520 == 2] 			; Werkzeugwechslertyp  0= Mache garnix 1 = Nur WPos Anfahren 2= WPos anfahren  + Vermessen 
		    gosub user_2			; Werkzeuglngenmessung aufrufen  [ACHTUNG - Muss unbedingt nach M6 T.. gemacht werden]
		ENDIF

		#5015 = 0				; Werkzeugwechsel ausgefhrt 1=Ja
	ENDIF
	;G01

    ENDIF						; Render Modus

endsub

;***************************************************************************************
sub config
;---------------------------------------------------------------------------------------
GoSub wzwp
GoSub znpp
GoSub wlmp
GoSub NL3D
GoSub SPWL
endsub

;***************************************************************************************
sub WZWP
;---------------------------------------------------------------------------------------
;0= Mache garnix 1 = Nur WPos Anfahren 2= WPos anfahren  + Vermessen
Dlgmsg "Bitte Werkzeugwechslertyp eingeben" "TYP" 4520  
if [#5398 == 1] ;OK
	IF [#4520 > 0 ] THEN
		Dlgmsg "Bitte Werkzeugwechselposition eingeben" "Position X-Achse" 4521 "Position Y-Achse" 4522 "Position Z-Achse" 4523
		
	ENDIF

ENDIF
endsub
;***************************************************************************************
sub ZNPP
;---------------------------------------------------------------------------------------
	Dlgmsg "Bitte Z-Nullpunktsensordaten eingeben" "TYP 0=ffner, 1=schliesser" 4400 "Hhe Sensor" 4510 "Anfahrvorschub:" 4512 "Tastvorschub:" 4513
endsub

;***************************************************************************************
sub WLMP
;---------------------------------------------------------------------------------------
	Dlgmsg "Position nach Referenzfahrt" "Position nach Referenz X:" 4631 "Position nach Referenz Y:" 4632 "Position nach Referenz Z:" 4633
	Dlgmsg "Bitte Werkzeuglngensensordaten eingeben" "Position X-Achse" 4507 "Position Y-Achse" 4508 "Sicherheitshhe Z" 4506 "SP. ohne Werkzeug" 4509 "Max. Werkzeuglnge" 4503 "Anfahrvorschub:" 4504 "Tastvorschub:" 4505
	Dlgmsg "Daten Bruchkontrolle" "Bruchkontrolle aktivieren?" 4529 "Verschleisstoleranz +/- in mm:" 4528  
	Dlgmsg "Position nach Messung anfahren" "Funktion:" 4519 "Position X-Achse" 4524 "Position Y-Achse" 4525 

;#4519 Was tun nach Werkzeugvermessung: 
;0= vordefinierten Punkt anfahren
;1= Werkstcknullpunkt fahren 
;2= Werkzeugwechselpos anfahren
;3= Maschinennullpunkt anfahren
;4= Stehen bleiben
;#4524 Position X nach Lngenmessung   
;#4525 Position Y nach Lngenmessung
;#4526 Position Z nach Lngenmessung
endsub
;***************************************************************************************
sub NL3D
;---------------------------------------------------------------------------------------
;   #4551 Nullpunktermittlung Versatz X+
;   #4552 Nullpunktermittlung Versatz X-
;   #4553 Nullpunktermittlung Versatz Y+
;   #4554 Nullpunktermittlung Versatz Y-
	Dlgmsg "Versatz 3D Taster.." "in Richtung X+" 4551 "in Richtung X-" 4552 "in Richtung Y+" 4553 "in Richtung Y-" 4554 
ENDSUB

;***************************************************************************************
sub SPWL
;---------------------------------------------------------------------------------------
;   #4532 Drehzahl Stufe 1 fr Warmlauf Spindel
;   #4533 Laufzeit Stufe 1 fr Warmlauf Spindel
;   #4534 Drehzahl Stufe 2 fr Warmlauf Spindel
;   #4535 Laufzeit Stufe 2 fr Warmlauf Spindel
;   #4536 Drehzahl Stufe 3 fr Warmlauf Spindel
;   #4537 Laufzeit Stufe 3 fr Warmlauf Spindel
;   #4538 Drehzahl Stufe 4 fr Warmlauf Spindel
;   #4539 Laufzeit Stufe 4 fr Warmlauf Spindel
	Dlgmsg "Spindelwarmlaufparameter" "Drehzahl Stufe 1" 4532 "Laufzeit (sek.) Stufe 1" 4533 "Drehzahl Stufe 2" 4534 "Laufzeit(sek.) Stufe 2" 4535 "Drehzahl Stufe 3" 4536 "Laufzeit (sek.) Stufe 3" 4537 "Drehzahl Stufe 4" 4538 "Laufzeit(sek.) Stufe 4" 4539
ENDSUB


;***************************************************************************************
sub zhcmgrid
;***************************************************************************************
;probe scanning routine for eneven surface milling
;scanning starts at x=0, y=0

  if [#4100 == 0]
   #4100 = 10  ;nx
   #4101 = 5   ;ny
   #4102 = 40  ;max z 
   #4103 = 10  ;min z 
   #4104 = 1.0 ;step size
   #4105 = 100 ;probing feed
  endif    

  #110 = 0    ;Actual nx
  #111 = 0    ;Actual ny
  #112 = 0    ;Missed measurements counter
  #113 = 0    ;Number of points added

  ;Dialog
  dlgmsg "gridMeas" "nx" 4100 "ny" 4101 "maxZ" 4102 "minZ" 4103 "gridSize" 4104 "Feed" 4105 
    
  if [#5398 == 1] ; user pressed OK
    ;Move to startpoint
    g0 z[#4102];to upper Z
    g0 x0 y0 ;to start point
        
    ;ZHCINIT gridSize nx ny
    ZHCINIT [#4104] [#4100] [#4101] 
    
    #111 = 0    ;Actual ny value
    while [#111 < #4101]
      #110 = 0
      while [#110 < #4100]
        ;Go up, goto xy, measure
        g0 z[#4102];to upper Z
        g0 x[#110 * #4104] y[#111 * #4104] ;to new scan point
        g38.2 F[#4105] z[#4103];probe down until touch
                
        ;Add point to internal table if probe has touched
        if [#5067 == 1]
          ZHCADDPOINT
          msg "nx="[#110 +1]" ny="[#111+1]" added"
          #113 = [#113+1]
        else
          ;ZHCADDPOINT
          msg "nx="[#110 +1]" ny="[#111+1]" not added"
          #112 = [#112+1]
        endif

        #110 = [#110 + 1] ;next nx
      endwhile
      #111 = [#111 + 1] ;next ny
    endwhile
        
    g0 z[#4102];to upper Z
    ;Save measured table
    ZHCS zHeightCompTable.txt
    msg "Done, "#113" points added, "#112" not added" 
        
  else
    ;user pressed cancel in dialog
    msg "Operation canceled"
  endif
endsub

;***************************************************************************************
; Handradfunktionen
;---------------------------------------------------------------------------------------
;***************************************************************************************
 SUB xhc_probe_z ;Z-Nullpunktermittlung
;---------------------------------------------------------------------------------------
	#3505 = 1					; Merker ob Lngenmessung von Handrad 1=Handrad
	gosub user_1 ;Z-Nullpunktermittlung
ENDSUB

;***************************************************************************************
SUB xhc_macro_1
;---------------------------------------------------------------------------------------
	msg"Keine Funktion fr Macro 1 Hinterlegt"
ENDSUB

;***************************************************************************************
SUB xhc_macro_2
;---------------------------------------------------------------------------------------
	gosub user_2 ;Werkzeugvermessung
ENDSUB
;***************************************************************************************
SUB xhc_macro_3
;---------------------------------------------------------------------------------------
	msg"Keine Funktion fr Macro 3 Hinterlegt"
ENDSUB
;***************************************************************************************
SUB xhc_macro_6
;---------------------------------------------------------------------------------------
	msg"Keine Funktion fr Macro 6 Hinterlegt"
ENDSUB
;***************************************************************************************
SUB xhc_macro_7
;---------------------------------------------------------------------------------------
	msg"Keine Funktion fr Macro 7 Hinterlegt"
ENDSUB

